/*
jvmtest - Java VM Invocation Test Program
Copyright (C) 2003 Trevor A. Robinson

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "jvminvoke.h"

int main(int argc, char **argv)
{
    char jvmpath[255];

    if (getJVMPath("client", jvmpath, sizeof(jvmpath)) == JNI_OK) {
        CreateJavaVMPtr pfcvm;

        printf("Found JVM library: %s\n", jvmpath);

        if (loadJVMLibrary(jvmpath, &pfcvm) == JNI_OK) {
            JavaVMOption options[1];
            JavaVMInitArgs args;
            JavaVM *pvm;
            JNIEnv *penv;

            printf("JVM library loaded (create function @ %p)\n", pfcvm);

            options[0].optionString = "-Djava.class.path=.";

            args.version = JNI_VERSION_1_2;
            args.nOptions = 1;
            args.options = options;
            args.ignoreUnrecognized = JNI_FALSE;

            if (createJVM(pfcvm, &args, &pvm, &penv) == JNI_OK) {
                const char* args[1];

                printf("JVM created\n");

                args[0] = "Java";
                executeClass(penv, "JVMTest", 1, args);
                destroyJVM(pvm);
            }
        }
    }
}
